



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>GraphQL 01--- GraphQL 介绍及资源总结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">GraphQL 01--- GraphQL 介绍及资源总结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-22 02:14:56 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>作为一位web开发人员，在使用REST API的时候，是否遇到过这样的问题：　　</p>
<p>　　1.调用一个API的时候，总是会返回一些不需要的信息。</p>
<p>　　2. 对于一个资源的调用，如果想获取到更多的信息，可能需要发送多次请求才能获取。</p>
<p>那么现在是时候了解一下GraphQL了。</p>
<p>一、什么是GraphQL？</p>
<p>　　GraphQL是FaceBook于2012年在内部开发的数据查询语言，在2015年开源，旨在提供RESTful架构的替代方案。根据官网的介绍：</p>
<blockquote><p>GraphQL is a query language for APIs and a runtime for fulfilling those queries with your existing data. GraphQL provides a complete and understandable description of the data in your API, gives clients the power to ask for exactly what they need and nothing more, makes it easier to evolve APIs over time, and enables powerful developer&nbsp;tools.</p></blockquote>
<div>　　GraphQL 既是一种用于 API 的查询语言也是一个满足你数据查询的运行时。 GraphQL 对你的 API 中的数据提供了一套易于理解的完整描述，使得客户端能够准确地获得它需要的数据，而且没有任何冗余，也让 API 更容易地随着时间推移而演进，还能用于构建强大的开发者工具。----&nbsp;</div>
<div>来源：掘金</div>
<p>二、为什么使用GraphQL？</p>
<p>　　在介绍这个问题之前，先来看看REST的API吧。</p>
<p>　　在使用了 RPC 远程过程调用接口之后，你会发现REST API的优越，这正是你梦寐以求的API定义模式。</p>
<ul><li><ul><li>对于系统本身耦合性低，调用者不再需要了解接口内部处理和实现细节</li>
<li>重复使用了一些 http 协议中的已定义好的部分状态动词，增强语义表现力</li>
<li>API可以随着时间而不断演进</li></ul></li></ul>
<p>　　但随着项目的开展，你会发现有这样一些问题：</p>
<p>　　当需要查询一个实体数据集的时候，如购物系统查询一本书籍，按照接口的定义，我们可以获取到一本书籍的所有信息。如他的ISBN，ID，name，价格，描述，等等信息。</p>
<p>　　问题:</p>
<p>　　1. 对于查询数据的接口，有时候需要获取数据的信息不一样，如在手机APP上，我可能需要一本书籍的ID，Name，价格。在Web应用上，我可能需要获取一本书籍的ISBN，Name，价格，描述等信息。这时候应该怎么办？</p>
<p>　　　　如果只定义一个接口，那么在手机APP上获取的数据有部分内容是冗余字段。如果定义多个接口，代码会有很多冗余代码。</p>
<p>　　2. 同样对于查询数据接口，如果获取书籍的数据的同时，我还需要获取到最近这本书籍的评价，以及相关附加信息(如标签，卖家信息)。这时候怎么办？</p>
<p>　　　　你可能会说，多设计几个接口，然后根据书籍的ID 等信息，多发送几次请求，就可以获取到相关信息了。但多发送几次请求，就多传递了很多附加信息。在网络带宽低的时候，也许就是个灾难了。</p>
<p>　　对于这两个问题，作为前端工程师的你可能需要追着后端开发工程师，希望他能给你提供一个便捷的方案。如改接口什么的，对于公司项目，尤其是多端(web、App、小程序等)的项目，改接口可能是牵一发而动全身的工作。</p>
<p>　　那么这个时候GraphQL闪亮登场：</p>
<p>　　就像GraphQL官方文档中说的：(要你想要的)</p>
<blockquote><p>Ask for what you need,&nbsp;get exactly that</p></blockquote>
<p>三、谁在使用GraphQL</p>
<p>　　Facebook当然不用说，全球最大同性交友网站GitHub, Twitter,国内好像现在比较少。</p>
<p>四、GraphQL资源总结：</p>
<ul><li>官网<a href="https://graphql.github.io/" rel="external nofollow noreferrer">https://graphql.github.io/</a></li>
<li>中文官网<a href="http://graphql.cn/" rel="external nofollow noreferrer">http://graphql.cn/</a></li>
<li>GraphQL 使用指南<a href="https://www.howtographql.com/" rel="external nofollow noreferrer">https://www.howtographql.com/</a></li>
<li>Prisma&nbsp;<a href="https://www.prisma.io/with-graphql/" rel="external nofollow noreferrer">https://www.prisma.io/with-graphql/</a></li>
<li>Apollo Graph&nbsp;&nbsp;<a href="https://www.apollographql.com/" rel="external nofollow noreferrer">https://www.apollographql.com/</a></li>
<li>GraphQL .Net&nbsp;<a href="https://graphql-dotnet.github.io/docs/getting-started/introduction/" rel="external nofollow noreferrer">https://graphql-dotnet.github.io/docs/getting-started/introduction/</a>&nbsp;(后续的如何使用GraphQL的Demo就是参照这个文档写的)</li></ul>
<p>下篇文章将介绍<a href="https://www.cnblogs.com/kingkangstudy/p/10471751.html" rel="external nofollow noreferrer">如何使用GraphQL.Net 与C#&nbsp; 结合</a></p>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvj1yqx.html">扑面而来的碎片--图片3D炸裂效果初体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyd422q.html">6-1 bash脚本编程之四 整数测试及特殊变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2we4xq.html">关于闭包（closure）的一些概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2j5oo8.html">修改Firebug字体</a>
		</li>
						<li><a href="https://www.batexi.com/a/4950d7e8.html">将做好的py文件打包成模块，供别人安装调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ev02x9.html">SQL问题集锦</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rvk148.html">ArcGIS Add-in&mdash;&mdash;自动保存编辑</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96x7d49.html">Discuz&excl; X的CSS加载机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mgowo8.html">最大权闭合图 &amp;amp&semi;&amp;amp&semi; 【BZOJ】1497&colon; &lbrack;NOI2006&rsqb;最大获利</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn50rz8.html">context&colon;property-placeholder</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wr7v3q.html">给进程分配cpu核心</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mrkrm8.html">vector成员函数解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mpzdo8.html">用queue函数写广搜</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mekgn2q.html">vs2010等宽字体设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo6561q.html">YYHS-Super Big Stupid Cross（二分&plus;扫描线&plus;平衡树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j7jyx8.html">在Linux下用gcc编译hello world</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wv5wrq.html">【转】C&num; 高性能 TCP 服务的多种实现方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2k7npq.html">&lbrack;转载&rsqb; HTTP 协议中 URI 和 URL 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o05ne8.html">重新编译安装swoole支持OpenSSL</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy7vkd9.html">web站点健康检测和告警小脚本</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kp7lg39.html">大白话 Scala 控制抽象</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp23yvq.html">&lbrack;LOJ3086&rsqb;&lbrack;GXOI&sol;GZOI2019&rsqb;逼死强迫症&mdash;&mdash;递推&plus;矩阵乘法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1lp7oq.html">jatoolsprinter html实现每隔几秒获取数据直接后台打印不弹窗</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz37jw8.html">placeholder中文字添加换行方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1lw21q.html">&lbrack;unix&rsqb;commvault在unix系统上本地安装报&OpenCurlyDoubleQuote;NFS directory cannot be used&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zr15x9.html">Python学习day17 迭代器&amp;amp&semi;生成器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp24w7q.html">ReactNative开发笔记（持续更新&period;&period;&period;）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k37509.html">JSP中EL很常用，怎样使用大于号、小于号、等于号等</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me05g6q.html">python中&lowbar;&lowbar;init&lowbar;&lowbar;和&lowbar;&lowbar;new&lowbar;&lowbar;的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/950o40z8.html">编译VisualVM源码解决乱码问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
